import { PgConditionStep } from "@dataplan/pg";
import { PgCodec } from "@dataplan/pg";
import { ExecutableStep, InputObjectFieldApplyPlanResolver, InputStep } from "grafast";
import type { GraphQLInputType } from "graphql";
import { SQL } from "pg-sql2";
export declare const PgConnectionArgFilterOperatorsPlugin: GraphileConfig.Plugin;
type PlaceholderableStep = {
    placeholder(step: ExecutableStep, codec: PgCodec<any, any, any, any, any, any, any>): SQL;
};
export interface OperatorSpec {
    name?: string;
    description: string;
    resolveSqlIdentifier?: (sqlIdentifier: SQL, codec: PgCodec<any, any, any, any, any, any, any>) => readonly [SQL, PgCodec<any, any, any, any, any, any, any>];
    resolveInput?: (input: unknown) => unknown;
    resolveInputCodec?: (expressionCodec: PgCodec<any, any, any, any, any, any, any>) => PgCodec<any, any, any, any, any, any, any>;
    resolveSql?: any;
    resolveSqlValue?: ($placeholderable: PlaceholderableStep, $input: InputStep, codec: PgCodec<any, any, any, any, any, any, any>) => SQL;
    resolve: (sqlIdentifier: SQL, sqlValue: SQL, $input: InputStep, $placeholderable: PlaceholderableStep) => SQL;
    resolveType?: (type: GraphQLInputType) => GraphQLInputType;
}
export declare function makeApplyPlanFromOperatorSpec(build: GraphileBuild.Build, typeName: string, fieldName: string, spec: OperatorSpec, type: GraphQLInputType): InputObjectFieldApplyPlanResolver<PgConditionStep<any>>;
export {};
