"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostGraphileConnectionFilterPreset = exports.makeApplyPlanFromOperatorSpec = void 0;
const ConnectionArgFilterPlugin_1 = require("./ConnectionArgFilterPlugin");
const PgConnectionArgFilterPlugin_1 = require("./PgConnectionArgFilterPlugin");
const PgConnectionArgFilterAttributesPlugin_1 = require("./PgConnectionArgFilterAttributesPlugin");
const PgConnectionArgFilterComputedAttributesPlugin_1 = require("./PgConnectionArgFilterComputedAttributesPlugin");
const PgConnectionArgFilterCompositeTypeAttributesPlugin_1 = require("./PgConnectionArgFilterCompositeTypeAttributesPlugin");
const PgConnectionArgFilterRecordFunctionsPlugin_1 = require("./PgConnectionArgFilterRecordFunctionsPlugin");
const PgConnectionArgFilterBackwardRelationsPlugin_1 = require("./PgConnectionArgFilterBackwardRelationsPlugin");
const PgConnectionArgFilterForwardRelationsPlugin_1 = require("./PgConnectionArgFilterForwardRelationsPlugin");
const PgConnectionArgFilterLogicalOperatorsPlugin_1 = require("./PgConnectionArgFilterLogicalOperatorsPlugin");
const PgConnectionArgFilterOperatorsPlugin_1 = require("./PgConnectionArgFilterOperatorsPlugin");
Object.defineProperty(exports, "makeApplyPlanFromOperatorSpec", { enumerable: true, get: function () { return PgConnectionArgFilterOperatorsPlugin_1.makeApplyPlanFromOperatorSpec; } });
const interfaces_1 = require("./interfaces");
const AddConnectionFilterOperatorPlugin_1 = require("./AddConnectionFilterOperatorPlugin");
exports.PostGraphileConnectionFilterPreset = {
    plugins: [
        ConnectionArgFilterPlugin_1.ConnectionArgFilterPlugin,
        PgConnectionArgFilterPlugin_1.PgConnectionArgFilterPlugin,
        PgConnectionArgFilterAttributesPlugin_1.PgConnectionArgFilterAttributesPlugin,
        PgConnectionArgFilterComputedAttributesPlugin_1.PgConnectionArgFilterComputedAttributesPlugin,
        PgConnectionArgFilterCompositeTypeAttributesPlugin_1.PgConnectionArgFilterCompositeTypeAttributesPlugin,
        PgConnectionArgFilterRecordFunctionsPlugin_1.PgConnectionArgFilterRecordFunctionsPlugin,
        //if (connectionFilterRelations)
        PgConnectionArgFilterBackwardRelationsPlugin_1.PgConnectionArgFilterBackwardRelationsPlugin,
        //if (connectionFilterRelations)
        PgConnectionArgFilterForwardRelationsPlugin_1.PgConnectionArgFilterForwardRelationsPlugin,
        //if (connectionFilterLogicalOperators)
        PgConnectionArgFilterLogicalOperatorsPlugin_1.PgConnectionArgFilterLogicalOperatorsPlugin,
        PgConnectionArgFilterOperatorsPlugin_1.PgConnectionArgFilterOperatorsPlugin,
        AddConnectionFilterOperatorPlugin_1.AddConnectionFilterOperatorPlugin,
    ],
    schema: {
        //connectionFilterAllowedOperators,
        //connectionFilterAllowedFieldTypes,
        connectionFilterArrays: true,
        connectionFilterComputedColumns: true,
        //connectionFilterOperatorNames,
        connectionFilterRelations: false,
        connectionFilterSetofFunctions: true,
        connectionFilterLogicalOperators: true,
        connectionFilterAllowNullInput: false,
        connectionFilterAllowEmptyObjectInput: false,
    },
};
//# sourceMappingURL=index.js.map